#Programmeerproject Informaticawetenschappen
#Groep: XXXXXX
#snake game
#bronnen:
# https://www.geeksforgeeks.org/python-moving-an-object-in-PG/
# youtbe
# google
# stackoverflow
# https://www.techwithtim.net/tutorials/game-development-with-python
# https://medium.com/@wepypixel/step-by-step-guide-python-code-for-snake-game-development-3e0ec9f7522e

''' In de nieuwe snake game is het de bedoeling dat je met je snake (het groene vierkantje) de rode bewegende appel vangt.
Door deze appel te vangen krijg je steeds meer punten. Telkens als je een veelvoud van 5 in je punten behaalt beweegt 
de appel sneller en wordt de snake kleiner en wordt het moeilijker de appel te vangen. Wanneer de snake niet meer zichtbaar is heb je gewonnen. 
'''


# import PG module in this program:
import pygame as PG
import atexit as EXIT
import random
# from tkinter import *
# import turtle
print("The new snake game:")

class Snake(dict):
    body = []
    turns = {}
    def __init__(self, gameboard):
       

        # link met het spelveld
        self.bord = gameboard

        # object current co-ordinates
        self.x = 200
        self.y = 200

        # dimensions of the object
        self.width = 40
        self.height = 40

        # velocity / speed of movement
        self.vel = 2

        # color
        self.color = 'green'

        # lengte en score
        self.lengte = 1
        self.score = 0
        self.direction = "up"

    def move(self):
        if self.direction == 'LEFT':
            self.x -= self.vel
        elif self.direction == 'RIGHT':
            self.x += self.vel
        elif self.direction == 'UP':
            self.y -= self.vel
        elif self.direction == 'DOWN':
            self.y += self.vel


        # TODO: in plaats van handmatig bewegen
        # zou de slang automatisch bewegen
        # en de gebruiker verandert de richting

    def move(self, keys):
        # moving the object
        # if left arrow key is pressed
        if keys[PG.K_LEFT] and self.x>0:

            # decrement in x co-ordinate
            self.x -= self.vel

        # if left arrow key is pressed
        if keys[PG.K_RIGHT] and self.x<500-self.width:

            # increment in x co-ordinate
            self.x += self.vel

        #if left arrow key is pressed
        if keys[PG.K_UP] and self.y>0:

            # decrement in y co-ordinate
            self.y -= self.vel

        # if left arrow key is pressed
        if keys[PG.K_DOWN] and self.y<500-self.height:
        #   increment in y co-ordinate
            self.y += self.vel



        # drawing object on screen which is rectangle here
   
        PG.draw.rect(self.bord.win, (100, 200, 100), (self.x, self.y, self.width, self.height))
        

    def Eten(self):
        self.lengte += 1
        self.score += 1

        PG.draw.rect(self.bord.win, (100, 200, 100), (self.x, self.y, self.width, self.height))

        # TODO: lengte zichtbaar maken
        #       bv. door een lijst van segmenten aan te maken 

class Food(dict):
    def __init__(self, gameboard):

        # link met het spelveld
        self.bord = gameboard

        # object current co-ordinates
        self.x = 100
        self.y = 100

        # dimensions of the object
        self.width = 20
        self.height = 20

        self.x_dir=20
        self.y_dir=20

        # velocity / speed of movement
        self.vel = 2
        self.move_teller=0

    def nieuwe_pos(self, ):

        # toevallige positie
        self.x = random.randint(20, 480)
        self.y = random.randint(20, 480)

        PG.draw.rect(self.bord.win, ("red"), (self.x, self.y, self.width, self.height))

    def move(self, ):

        self.move_teller += self.vel
        if self.move_teller > 100:
            self.move_teller = 0
            self.x +=self.x_dir
            self.y +=self.y_dir
        

        if random.randint(0,100) < 10:
            self.x_dir =random.choice([-20,0,20])
            self.y_dir =random.choice([-20,0,20])

        if self.x<20:
            self.x += 20

        if self.x>500-self.width:
            self.x -= 20

        if self.y<20:
            self.y += 20

        if self.y>500-self.width:
           self.y -= 20


        PG.draw.rect(self.bord.win, ("red"), (self.x, self.y, self.width, self.height))
        


    def update(self):
        # drawing object on screen which is rectangle here
        PG.draw.rect(self.bord.win, (255, 100, 100), (self.x, self.y, self.width, self.height))



class Game(object):

    def __init__(self):
        # De initialisatie van een spel

        # activate the PG library .
        # initiate PG and give permission
        # to use PG's functionality.
        PG.init()
        self.punten=0
        # create the display surface object
        # of specific dimension..e(500, 500).
        self.spelveld = (500, 500)
        self.win = PG.display.set_mode(self.spelveld)

        # set the PG window name
        PG.display.set_caption("The snake game!")

        # het bewegend puntje
        self.slang = Snake(self)

        # iets te eten
        self.appel = Food(self)

        # zeker gaan dat alles goed afsluit
        EXIT.register(self.Quit)

    def run(self):
        # Indicates PG is running
        self.running = True

        # infinite loop
        while self.running:
            # creates time delay of 10ms
            PG.time.delay(10)

            # iterate over the list of Event objects
            # that was returned by PG.event.get() method.
            for event in PG.event.get():

                # if event object type is QUIT
                # then quitting the PG
                # and program both.
                if event.type == PG.QUIT:

                    # it will make exit the while loop
                    self.running = False

            # stores keys pressed
            keys = PG.key.get_pressed()


            # completely fill the surface object
            # with black colour
            self.win.fill((0, 0, 0))

            # de slang bewegen en de appel tonen
            self.slang.move(keys)
            self.appel.update()
            self.appel.move()

            # opeten
            self.IetsEten()

            # it refreshes the window
            PG.display.update()

    def IetsEten(self):
        slang_pos = [self.slang.x, self.slang.y]
        appel_pos = [self.appel.x, self.appel.y]

        if (abs(slang_pos[0] - appel_pos[0]) < self.slang.width) \
           and (abs(slang_pos[1] - appel_pos[1]) < self.slang.height):
            self.slang.Eten()
            self.appel.nieuwe_pos()
            self.punten +=1
            if (self.punten%5 == 0):
                self.appel.vel +=1
                self.slang.width -=1
                self.slang.height -=1
            print("Je hebt %d punten" %self.punten)




    def Quit(self):
        self.running = False
        # closes the PG window
        PG.quit()
        print("bedankt om te spelen!")



# MISSION CONTROL
if __name__ == "__main__":
    game = Game()
    # food = food()
    game.run()
